#include "nv_push_clcab5.h"

#include <stdio.h>

const char*
P_PARSE_NVCAB5_MTHD(uint16_t idx)
{
    switch (idx) {
    case NVCAB5_NOP:
        return "NVCAB5_NOP";
    case NVCAB5_PM_TRIGGER:
        return "NVCAB5_PM_TRIGGER";
    case NVCAB5_SET_MONITORED_FENCE_TYPE:
        return "NVCAB5_SET_MONITORED_FENCE_TYPE";
    case NVCAB5_SET_MONITORED_FENCE_SIGNAL_ADDR_BASE_UPPER:
        return "NVCAB5_SET_MONITORED_FENCE_SIGNAL_ADDR_BASE_UPPER";
    case NVCAB5_SET_MONITORED_FENCE_SIGNAL_ADDR_BASE_LOWER:
        return "NVCAB5_SET_MONITORED_FENCE_SIGNAL_ADDR_BASE_LOWER";
    case NVCAB5_SET_SEMAPHORE_A:
        return "NVCAB5_SET_SEMAPHORE_A";
    case NVCAB5_SET_SEMAPHORE_B:
        return "NVCAB5_SET_SEMAPHORE_B";
    case NVCAB5_SET_SEMAPHORE_PAYLOAD:
        return "NVCAB5_SET_SEMAPHORE_PAYLOAD";
    case NVCAB5_SET_RENDER_ENABLE_A:
        return "NVCAB5_SET_RENDER_ENABLE_A";
    case NVCAB5_SET_RENDER_ENABLE_B:
        return "NVCAB5_SET_RENDER_ENABLE_B";
    case NVCAB5_SET_RENDER_ENABLE_C:
        return "NVCAB5_SET_RENDER_ENABLE_C";
    case NVCAB5_SET_SRC_PHYS_MODE:
        return "NVCAB5_SET_SRC_PHYS_MODE";
    case NVCAB5_SET_DST_PHYS_MODE:
        return "NVCAB5_SET_DST_PHYS_MODE";
    case NVCAB5_LAUNCH_DMA:
        return "NVCAB5_LAUNCH_DMA";
    case NVCAB5_OFFSET_IN_UPPER:
        return "NVCAB5_OFFSET_IN_UPPER";
    case NVCAB5_OFFSET_IN_LOWER:
        return "NVCAB5_OFFSET_IN_LOWER";
    case NVCAB5_OFFSET_OUT_UPPER:
        return "NVCAB5_OFFSET_OUT_UPPER";
    case NVCAB5_OFFSET_OUT_LOWER:
        return "NVCAB5_OFFSET_OUT_LOWER";
    case NVCAB5_PITCH_IN:
        return "NVCAB5_PITCH_IN";
    case NVCAB5_PITCH_OUT:
        return "NVCAB5_PITCH_OUT";
    case NVCAB5_LINE_LENGTH_IN:
        return "NVCAB5_LINE_LENGTH_IN";
    case NVCAB5_LINE_COUNT:
        return "NVCAB5_LINE_COUNT";
    case NVCAB5_SET_SECURE_COPY_MODE:
        return "NVCAB5_SET_SECURE_COPY_MODE";
    case NVCAB5_SET_DECRYPT_AUTH_TAG_COMPARE_ADDR_UPPER:
        return "NVCAB5_SET_DECRYPT_AUTH_TAG_COMPARE_ADDR_UPPER";
    case NVCAB5_SET_DECRYPT_AUTH_TAG_COMPARE_ADDR_LOWER:
        return "NVCAB5_SET_DECRYPT_AUTH_TAG_COMPARE_ADDR_LOWER";
    case NVCAB5_SET_ENCRYPT_AUTH_TAG_ADDR_UPPER:
        return "NVCAB5_SET_ENCRYPT_AUTH_TAG_ADDR_UPPER";
    case NVCAB5_SET_ENCRYPT_AUTH_TAG_ADDR_LOWER:
        return "NVCAB5_SET_ENCRYPT_AUTH_TAG_ADDR_LOWER";
    case NVCAB5_SET_ENCRYPT_IV_ADDR_UPPER:
        return "NVCAB5_SET_ENCRYPT_IV_ADDR_UPPER";
    case NVCAB5_SET_ENCRYPT_IV_ADDR_LOWER:
        return "NVCAB5_SET_ENCRYPT_IV_ADDR_LOWER";
    case NVCAB5_SET_MEMORY_SCRUB_PARAMETERS:
        return "NVCAB5_SET_MEMORY_SCRUB_PARAMETERS";
    case NVCAB5_SET_REMAP_CONST_A:
        return "NVCAB5_SET_REMAP_CONST_A";
    case NVCAB5_SET_REMAP_CONST_B:
        return "NVCAB5_SET_REMAP_CONST_B";
    case NVCAB5_SET_REMAP_COMPONENTS:
        return "NVCAB5_SET_REMAP_COMPONENTS";
    case NVCAB5_SET_DST_BLOCK_SIZE:
        return "NVCAB5_SET_DST_BLOCK_SIZE";
    case NVCAB5_SET_DST_WIDTH:
        return "NVCAB5_SET_DST_WIDTH";
    case NVCAB5_SET_DST_HEIGHT:
        return "NVCAB5_SET_DST_HEIGHT";
    case NVCAB5_SET_DST_DEPTH:
        return "NVCAB5_SET_DST_DEPTH";
    case NVCAB5_SET_DST_LAYER:
        return "NVCAB5_SET_DST_LAYER";
    case NVCAB5_SET_DST_ORIGIN:
        return "NVCAB5_SET_DST_ORIGIN";
    case NVCAB5_SET_SRC_BLOCK_SIZE:
        return "NVCAB5_SET_SRC_BLOCK_SIZE";
    case NVCAB5_SET_SRC_WIDTH:
        return "NVCAB5_SET_SRC_WIDTH";
    case NVCAB5_SET_SRC_HEIGHT:
        return "NVCAB5_SET_SRC_HEIGHT";
    case NVCAB5_SET_SRC_DEPTH:
        return "NVCAB5_SET_SRC_DEPTH";
    case NVCAB5_SET_SRC_LAYER:
        return "NVCAB5_SET_SRC_LAYER";
    case NVCAB5_SET_SRC_ORIGIN:
        return "NVCAB5_SET_SRC_ORIGIN";
    case NVCAB5_SRC_ORIGIN_X:
        return "NVCAB5_SRC_ORIGIN_X";
    case NVCAB5_SRC_ORIGIN_Y:
        return "NVCAB5_SRC_ORIGIN_Y";
    case NVCAB5_DST_ORIGIN_X:
        return "NVCAB5_DST_ORIGIN_X";
    case NVCAB5_DST_ORIGIN_Y:
        return "NVCAB5_DST_ORIGIN_Y";
    case NVCAB5_PM_TRIGGER_END:
        return "NVCAB5_PM_TRIGGER_END";
    default:
        return "unknown method";
    }
}

void
P_DUMP_NVCAB5_MTHD_DATA(FILE *fp, uint16_t idx, uint32_t data,
                         const char *prefix)
{
    UNUSED uint32_t parsed;
    switch (idx) {
    case NVCAB5_NOP:
    
        parsed = data;
        fprintf(fp, "%s.PARAMETER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_PM_TRIGGER:
    
        parsed = data;
        fprintf(fp, "%s.V = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_MONITORED_FENCE_TYPE:
    
        parsed = (data >> 0) & ((1u << 1) - 1);
        fprintf(fp, "%s.TYPE = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_MONITORED_FENCE_TYPE_TYPE_MONITORED_FENCE:
            fprintf(fp, "MONITORED_FENCE\n");
            break;
        case NVCAB5_SET_MONITORED_FENCE_TYPE_TYPE_MONITORED_FENCE_EXT:
            fprintf(fp, "MONITORED_FENCE_EXT\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
        break;
    case NVCAB5_SET_MONITORED_FENCE_SIGNAL_ADDR_BASE_UPPER:
    
        parsed = (data >> 0) & ((1u << 25) - 1);
        fprintf(fp, "%s.UPPER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_MONITORED_FENCE_SIGNAL_ADDR_BASE_LOWER:
    
        parsed = data;
        fprintf(fp, "%s.LOWER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_SEMAPHORE_A:
    
        parsed = (data >> 0) & ((1u << 25) - 1);
        fprintf(fp, "%s.UPPER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_SEMAPHORE_B:
    
        parsed = data;
        fprintf(fp, "%s.LOWER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_SEMAPHORE_PAYLOAD:
    
        parsed = data;
        fprintf(fp, "%s.PAYLOAD = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
    
        parsed = data;
        fprintf(fp, "%s.UPPER_PAYLOAD = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_RENDER_ENABLE_A:
    
        parsed = (data >> 0) & ((1u << 25) - 1);
        fprintf(fp, "%s.UPPER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_RENDER_ENABLE_B:
    
        parsed = data;
        fprintf(fp, "%s.LOWER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_RENDER_ENABLE_C:
    
        parsed = (data >> 0) & ((1u << 3) - 1);
        fprintf(fp, "%s.MODE = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_RENDER_ENABLE_C_MODE_FALSE:
            fprintf(fp, "FALSE\n");
            break;
        case NVCAB5_SET_RENDER_ENABLE_C_MODE_TRUE:
            fprintf(fp, "TRUE\n");
            break;
        case NVCAB5_SET_RENDER_ENABLE_C_MODE_CONDITIONAL:
            fprintf(fp, "CONDITIONAL\n");
            break;
        case NVCAB5_SET_RENDER_ENABLE_C_MODE_RENDER_IF_EQUAL:
            fprintf(fp, "RENDER_IF_EQUAL\n");
            break;
        case NVCAB5_SET_RENDER_ENABLE_C_MODE_RENDER_IF_NOT_EQUAL:
            fprintf(fp, "RENDER_IF_NOT_EQUAL\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
        break;
    case NVCAB5_SET_SRC_PHYS_MODE:
    
        parsed = (data >> 0) & ((1u << 2) - 1);
        fprintf(fp, "%s.TARGET = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_SRC_PHYS_MODE_TARGET_LOCAL_FB:
            fprintf(fp, "LOCAL_FB\n");
            break;
        case NVCAB5_SET_SRC_PHYS_MODE_TARGET_COHERENT_SYSMEM:
            fprintf(fp, "COHERENT_SYSMEM\n");
            break;
        case NVCAB5_SET_SRC_PHYS_MODE_TARGET_NONCOHERENT_SYSMEM:
            fprintf(fp, "NONCOHERENT_SYSMEM\n");
            break;
        case NVCAB5_SET_SRC_PHYS_MODE_TARGET_PEERMEM:
            fprintf(fp, "PEERMEM\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 2) & ((1u << 4) - 1);
        fprintf(fp, "%s.BASIC_KIND = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
    
        parsed = (data >> 6) & ((1u << 3) - 1);
        fprintf(fp, "%s.PEER_ID = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
    
        parsed = (data >> 9) & ((1u << 1) - 1);
        fprintf(fp, "%s.FLA = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_DST_PHYS_MODE:
    
        parsed = (data >> 0) & ((1u << 2) - 1);
        fprintf(fp, "%s.TARGET = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_DST_PHYS_MODE_TARGET_LOCAL_FB:
            fprintf(fp, "LOCAL_FB\n");
            break;
        case NVCAB5_SET_DST_PHYS_MODE_TARGET_COHERENT_SYSMEM:
            fprintf(fp, "COHERENT_SYSMEM\n");
            break;
        case NVCAB5_SET_DST_PHYS_MODE_TARGET_NONCOHERENT_SYSMEM:
            fprintf(fp, "NONCOHERENT_SYSMEM\n");
            break;
        case NVCAB5_SET_DST_PHYS_MODE_TARGET_PEERMEM:
            fprintf(fp, "PEERMEM\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 2) & ((1u << 4) - 1);
        fprintf(fp, "%s.BASIC_KIND = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
    
        parsed = (data >> 6) & ((1u << 3) - 1);
        fprintf(fp, "%s.PEER_ID = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
    
        parsed = (data >> 9) & ((1u << 1) - 1);
        fprintf(fp, "%s.FLA = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_LAUNCH_DMA:
    
        parsed = (data >> 0) & ((1u << 2) - 1);
        fprintf(fp, "%s.DATA_TRANSFER_TYPE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_DATA_TRANSFER_TYPE_NONE:
            fprintf(fp, "NONE\n");
            break;
        case NVCAB5_LAUNCH_DMA_DATA_TRANSFER_TYPE_PIPELINED:
            fprintf(fp, "PIPELINED\n");
            break;
        case NVCAB5_LAUNCH_DMA_DATA_TRANSFER_TYPE_NON_PIPELINED:
            fprintf(fp, "NON_PIPELINED\n");
            break;
        case NVCAB5_LAUNCH_DMA_DATA_TRANSFER_TYPE_PREFETCH:
            fprintf(fp, "PREFETCH\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 2) & ((1u << 1) - 1);
        fprintf(fp, "%s.FLUSH_ENABLE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_FLUSH_ENABLE_FALSE:
            fprintf(fp, "FALSE\n");
            break;
        case NVCAB5_LAUNCH_DMA_FLUSH_ENABLE_TRUE:
            fprintf(fp, "TRUE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 25) & ((1u << 1) - 1);
        fprintf(fp, "%s.FLUSH_TYPE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_FLUSH_TYPE_SYS:
            fprintf(fp, "SYS\n");
            break;
        case NVCAB5_LAUNCH_DMA_FLUSH_TYPE_GL:
            fprintf(fp, "GL\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 3) & ((1u << 2) - 1);
        fprintf(fp, "%s.SEMAPHORE_TYPE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_TYPE_NONE:
            fprintf(fp, "NONE\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_TYPE_RELEASE_SEMAPHORE_NO_TIMESTAMP:
            fprintf(fp, "RELEASE_SEMAPHORE_NO_TIMESTAMP\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_TYPE_RELEASE_SEMAPHORE_WITH_TIMESTAMP:
            fprintf(fp, "RELEASE_SEMAPHORE_WITH_TIMESTAMP\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_TYPE_RELEASE_CONDITIONAL_INTR_SEMAPHORE:
            fprintf(fp, "RELEASE_CONDITIONAL_INTR_SEMAPHORE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 5) & ((1u << 2) - 1);
        fprintf(fp, "%s.INTERRUPT_TYPE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_INTERRUPT_TYPE_NONE:
            fprintf(fp, "NONE\n");
            break;
        case NVCAB5_LAUNCH_DMA_INTERRUPT_TYPE_BLOCKING:
            fprintf(fp, "BLOCKING\n");
            break;
        case NVCAB5_LAUNCH_DMA_INTERRUPT_TYPE_NON_BLOCKING:
            fprintf(fp, "NON_BLOCKING\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 7) & ((1u << 1) - 1);
        fprintf(fp, "%s.SRC_MEMORY_LAYOUT = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_SRC_MEMORY_LAYOUT_BLOCKLINEAR:
            fprintf(fp, "BLOCKLINEAR\n");
            break;
        case NVCAB5_LAUNCH_DMA_SRC_MEMORY_LAYOUT_PITCH:
            fprintf(fp, "PITCH\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 8) & ((1u << 1) - 1);
        fprintf(fp, "%s.DST_MEMORY_LAYOUT = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_DST_MEMORY_LAYOUT_BLOCKLINEAR:
            fprintf(fp, "BLOCKLINEAR\n");
            break;
        case NVCAB5_LAUNCH_DMA_DST_MEMORY_LAYOUT_PITCH:
            fprintf(fp, "PITCH\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 9) & ((1u << 1) - 1);
        fprintf(fp, "%s.MULTI_LINE_ENABLE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_MULTI_LINE_ENABLE_FALSE:
            fprintf(fp, "FALSE\n");
            break;
        case NVCAB5_LAUNCH_DMA_MULTI_LINE_ENABLE_TRUE:
            fprintf(fp, "TRUE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 10) & ((1u << 1) - 1);
        fprintf(fp, "%s.REMAP_ENABLE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_REMAP_ENABLE_FALSE:
            fprintf(fp, "FALSE\n");
            break;
        case NVCAB5_LAUNCH_DMA_REMAP_ENABLE_TRUE:
            fprintf(fp, "TRUE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 12) & ((1u << 1) - 1);
        fprintf(fp, "%s.SRC_TYPE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_SRC_TYPE_VIRTUAL:
            fprintf(fp, "VIRTUAL\n");
            break;
        case NVCAB5_LAUNCH_DMA_SRC_TYPE_PHYSICAL:
            fprintf(fp, "PHYSICAL\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 13) & ((1u << 1) - 1);
        fprintf(fp, "%s.DST_TYPE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_DST_TYPE_VIRTUAL:
            fprintf(fp, "VIRTUAL\n");
            break;
        case NVCAB5_LAUNCH_DMA_DST_TYPE_PHYSICAL:
            fprintf(fp, "PHYSICAL\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 14) & ((1u << 4) - 1);
        fprintf(fp, "%s.SEMAPHORE_REDUCTION = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_IMIN:
            fprintf(fp, "IMIN\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_IMAX:
            fprintf(fp, "IMAX\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_IXOR:
            fprintf(fp, "IXOR\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_IAND:
            fprintf(fp, "IAND\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_IOR:
            fprintf(fp, "IOR\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_IADD:
            fprintf(fp, "IADD\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_INC:
            fprintf(fp, "INC\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_DEC:
            fprintf(fp, "DEC\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_INVALIDA:
            fprintf(fp, "INVALIDA\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_INVALIDB:
            fprintf(fp, "INVALIDB\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_FADD:
            fprintf(fp, "FADD\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_FMIN:
            fprintf(fp, "FMIN\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_FMAX:
            fprintf(fp, "FMAX\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_INVALIDC:
            fprintf(fp, "INVALIDC\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_INVALIDD:
            fprintf(fp, "INVALIDD\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_INVALIDE:
            fprintf(fp, "INVALIDE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 18) & ((1u << 1) - 1);
        fprintf(fp, "%s.SEMAPHORE_REDUCTION_SIGN = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_SIGN_SIGNED:
            fprintf(fp, "SIGNED\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_SIGN_UNSIGNED:
            fprintf(fp, "UNSIGNED\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 19) & ((1u << 1) - 1);
        fprintf(fp, "%s.SEMAPHORE_REDUCTION_ENABLE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_ENABLE_FALSE:
            fprintf(fp, "FALSE\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_REDUCTION_ENABLE_TRUE:
            fprintf(fp, "TRUE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 20) & ((1u << 2) - 1);
        fprintf(fp, "%s.COPY_TYPE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_COPY_TYPE_PROT2PROT:
            fprintf(fp, "PROT2PROT\n");
            break;
        case NVCAB5_LAUNCH_DMA_COPY_TYPE_SECURE:
            fprintf(fp, "SECURE\n");
            break;
        case NVCAB5_LAUNCH_DMA_COPY_TYPE_NONPROT2NONPROT:
            fprintf(fp, "NONPROT2NONPROT\n");
            break;
        case NVCAB5_LAUNCH_DMA_COPY_TYPE_RESERVED:
            fprintf(fp, "RESERVED\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 22) & ((1u << 1) - 1);
        fprintf(fp, "%s.VPRMODE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_VPRMODE_VPR_NONE:
            fprintf(fp, "VPR_NONE\n");
            break;
        case NVCAB5_LAUNCH_DMA_VPRMODE_VPR_VID2VID:
            fprintf(fp, "VPR_VID2VID\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 23) & ((1u << 1) - 1);
        fprintf(fp, "%s.MEMORY_SCRUB_ENABLE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_MEMORY_SCRUB_ENABLE_FALSE:
            fprintf(fp, "FALSE\n");
            break;
        case NVCAB5_LAUNCH_DMA_MEMORY_SCRUB_ENABLE_TRUE:
            fprintf(fp, "TRUE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 24) & ((1u << 1) - 1);
        fprintf(fp, "%s.RESERVED_START_OF_COPY = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
    
        parsed = (data >> 26) & ((1u << 1) - 1);
        fprintf(fp, "%s.DISABLE_PLC = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_DISABLE_PLC_FALSE:
            fprintf(fp, "FALSE\n");
            break;
        case NVCAB5_LAUNCH_DMA_DISABLE_PLC_TRUE:
            fprintf(fp, "TRUE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 27) & ((1u << 1) - 1);
        fprintf(fp, "%s.SEMAPHORE_PAYLOAD_SIZE = ", prefix);
        switch (parsed) {
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_PAYLOAD_SIZE_ONE_WORD:
            fprintf(fp, "ONE_WORD\n");
            break;
        case NVCAB5_LAUNCH_DMA_SEMAPHORE_PAYLOAD_SIZE_TWO_WORD:
            fprintf(fp, "TWO_WORD\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 28) & ((1u << 4) - 1);
        fprintf(fp, "%s.RESERVED_ERR_CODE = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_OFFSET_IN_UPPER:
    
        parsed = (data >> 0) & ((1u << 25) - 1);
        fprintf(fp, "%s.UPPER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_OFFSET_IN_LOWER:
    
        parsed = data;
        fprintf(fp, "%s.VALUE = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_OFFSET_OUT_UPPER:
    
        parsed = (data >> 0) & ((1u << 25) - 1);
        fprintf(fp, "%s.UPPER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_OFFSET_OUT_LOWER:
    
        parsed = data;
        fprintf(fp, "%s.VALUE = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_PITCH_IN:
    
        parsed = data;
        fprintf(fp, "%s.VALUE = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_PITCH_OUT:
    
        parsed = data;
        fprintf(fp, "%s.VALUE = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_LINE_LENGTH_IN:
    
        parsed = data;
        fprintf(fp, "%s.VALUE = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_LINE_COUNT:
    
        parsed = data;
        fprintf(fp, "%s.VALUE = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_SECURE_COPY_MODE:
    
        parsed = (data >> 0) & ((1u << 1) - 1);
        fprintf(fp, "%s.MODE = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_SECURE_COPY_MODE_MODE_ENCRYPT:
            fprintf(fp, "ENCRYPT\n");
            break;
        case NVCAB5_SET_SECURE_COPY_MODE_MODE_DECRYPT:
            fprintf(fp, "DECRYPT\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
        break;
    case NVCAB5_SET_DECRYPT_AUTH_TAG_COMPARE_ADDR_UPPER:
    
        parsed = (data >> 0) & ((1u << 25) - 1);
        fprintf(fp, "%s.UPPER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_DECRYPT_AUTH_TAG_COMPARE_ADDR_LOWER:
    
        parsed = data;
        fprintf(fp, "%s.LOWER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_ENCRYPT_AUTH_TAG_ADDR_UPPER:
    
        parsed = (data >> 0) & ((1u << 25) - 1);
        fprintf(fp, "%s.UPPER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_ENCRYPT_AUTH_TAG_ADDR_LOWER:
    
        parsed = data;
        fprintf(fp, "%s.LOWER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_ENCRYPT_IV_ADDR_UPPER:
    
        parsed = (data >> 0) & ((1u << 25) - 1);
        fprintf(fp, "%s.UPPER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_ENCRYPT_IV_ADDR_LOWER:
    
        parsed = data;
        fprintf(fp, "%s.LOWER = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_MEMORY_SCRUB_PARAMETERS:
    
        parsed = (data >> 0) & ((1u << 1) - 1);
        fprintf(fp, "%s.DISCARDABLE = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_MEMORY_SCRUB_PARAMETERS_DISCARDABLE_FALSE:
            fprintf(fp, "FALSE\n");
            break;
        case NVCAB5_SET_MEMORY_SCRUB_PARAMETERS_DISCARDABLE_TRUE:
            fprintf(fp, "TRUE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
        break;
    case NVCAB5_SET_REMAP_CONST_A:
    
        parsed = data;
        fprintf(fp, "%s.V = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_REMAP_CONST_B:
    
        parsed = data;
        fprintf(fp, "%s.V = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_REMAP_COMPONENTS:
    
        parsed = (data >> 0) & ((1u << 3) - 1);
        fprintf(fp, "%s.DST_X = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_REMAP_COMPONENTS_DST_X_SRC_X:
            fprintf(fp, "SRC_X\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_X_SRC_Y:
            fprintf(fp, "SRC_Y\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_X_SRC_Z:
            fprintf(fp, "SRC_Z\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_X_SRC_W:
            fprintf(fp, "SRC_W\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_X_CONST_A:
            fprintf(fp, "CONST_A\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_X_CONST_B:
            fprintf(fp, "CONST_B\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_X_NO_WRITE:
            fprintf(fp, "NO_WRITE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 4) & ((1u << 3) - 1);
        fprintf(fp, "%s.DST_Y = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Y_SRC_X:
            fprintf(fp, "SRC_X\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Y_SRC_Y:
            fprintf(fp, "SRC_Y\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Y_SRC_Z:
            fprintf(fp, "SRC_Z\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Y_SRC_W:
            fprintf(fp, "SRC_W\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Y_CONST_A:
            fprintf(fp, "CONST_A\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Y_CONST_B:
            fprintf(fp, "CONST_B\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Y_NO_WRITE:
            fprintf(fp, "NO_WRITE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 8) & ((1u << 3) - 1);
        fprintf(fp, "%s.DST_Z = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Z_SRC_X:
            fprintf(fp, "SRC_X\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Z_SRC_Y:
            fprintf(fp, "SRC_Y\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Z_SRC_Z:
            fprintf(fp, "SRC_Z\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Z_SRC_W:
            fprintf(fp, "SRC_W\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Z_CONST_A:
            fprintf(fp, "CONST_A\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Z_CONST_B:
            fprintf(fp, "CONST_B\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_Z_NO_WRITE:
            fprintf(fp, "NO_WRITE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 12) & ((1u << 3) - 1);
        fprintf(fp, "%s.DST_W = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_REMAP_COMPONENTS_DST_W_SRC_X:
            fprintf(fp, "SRC_X\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_W_SRC_Y:
            fprintf(fp, "SRC_Y\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_W_SRC_Z:
            fprintf(fp, "SRC_Z\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_W_SRC_W:
            fprintf(fp, "SRC_W\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_W_CONST_A:
            fprintf(fp, "CONST_A\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_W_CONST_B:
            fprintf(fp, "CONST_B\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_DST_W_NO_WRITE:
            fprintf(fp, "NO_WRITE\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 16) & ((1u << 2) - 1);
        fprintf(fp, "%s.COMPONENT_SIZE = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_REMAP_COMPONENTS_COMPONENT_SIZE_ONE:
            fprintf(fp, "ONE\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_COMPONENT_SIZE_TWO:
            fprintf(fp, "TWO\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_COMPONENT_SIZE_THREE:
            fprintf(fp, "THREE\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_COMPONENT_SIZE_FOUR:
            fprintf(fp, "FOUR\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 20) & ((1u << 2) - 1);
        fprintf(fp, "%s.NUM_SRC_COMPONENTS = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_REMAP_COMPONENTS_NUM_SRC_COMPONENTS_ONE:
            fprintf(fp, "ONE\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_NUM_SRC_COMPONENTS_TWO:
            fprintf(fp, "TWO\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_NUM_SRC_COMPONENTS_THREE:
            fprintf(fp, "THREE\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_NUM_SRC_COMPONENTS_FOUR:
            fprintf(fp, "FOUR\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 24) & ((1u << 2) - 1);
        fprintf(fp, "%s.NUM_DST_COMPONENTS = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_REMAP_COMPONENTS_NUM_DST_COMPONENTS_ONE:
            fprintf(fp, "ONE\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_NUM_DST_COMPONENTS_TWO:
            fprintf(fp, "TWO\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_NUM_DST_COMPONENTS_THREE:
            fprintf(fp, "THREE\n");
            break;
        case NVCAB5_SET_REMAP_COMPONENTS_NUM_DST_COMPONENTS_FOUR:
            fprintf(fp, "FOUR\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
        break;
    case NVCAB5_SET_DST_BLOCK_SIZE:
    
        parsed = (data >> 0) & ((1u << 4) - 1);
        fprintf(fp, "%s.WIDTH = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_DST_BLOCK_SIZE_WIDTH_ONE_GOB:
            fprintf(fp, "ONE_GOB\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 4) & ((1u << 4) - 1);
        fprintf(fp, "%s.HEIGHT = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_DST_BLOCK_SIZE_HEIGHT_ONE_GOB:
            fprintf(fp, "ONE_GOB\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_HEIGHT_TWO_GOBS:
            fprintf(fp, "TWO_GOBS\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_HEIGHT_FOUR_GOBS:
            fprintf(fp, "FOUR_GOBS\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_HEIGHT_EIGHT_GOBS:
            fprintf(fp, "EIGHT_GOBS\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_HEIGHT_SIXTEEN_GOBS:
            fprintf(fp, "SIXTEEN_GOBS\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_HEIGHT_THIRTYTWO_GOBS:
            fprintf(fp, "THIRTYTWO_GOBS\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 8) & ((1u << 4) - 1);
        fprintf(fp, "%s.DEPTH = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_DST_BLOCK_SIZE_DEPTH_ONE_GOB:
            fprintf(fp, "ONE_GOB\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_DEPTH_TWO_GOBS:
            fprintf(fp, "TWO_GOBS\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_DEPTH_FOUR_GOBS:
            fprintf(fp, "FOUR_GOBS\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_DEPTH_EIGHT_GOBS:
            fprintf(fp, "EIGHT_GOBS\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_DEPTH_SIXTEEN_GOBS:
            fprintf(fp, "SIXTEEN_GOBS\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_DEPTH_THIRTYTWO_GOBS:
            fprintf(fp, "THIRTYTWO_GOBS\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 12) & ((1u << 4) - 1);
        fprintf(fp, "%s.GOB_HEIGHT = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_DST_BLOCK_SIZE_GOB_HEIGHT_GOB_HEIGHT_FERMI_8:
            fprintf(fp, "GOB_HEIGHT_FERMI_8\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 16) & ((1u << 2) - 1);
        fprintf(fp, "%s.KIND_BPP = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_DST_BLOCK_SIZE_KIND_BPP_BL_32:
            fprintf(fp, "BL_32\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_KIND_BPP_BL_8:
            fprintf(fp, "BL_8\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_KIND_BPP_BL_16:
            fprintf(fp, "BL_16\n");
            break;
        case NVCAB5_SET_DST_BLOCK_SIZE_KIND_BPP_BL_24:
            fprintf(fp, "BL_24\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
        break;
    case NVCAB5_SET_DST_WIDTH:
    
        parsed = data;
        fprintf(fp, "%s.V = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_DST_HEIGHT:
    
        parsed = data;
        fprintf(fp, "%s.V = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_DST_DEPTH:
    
        parsed = data;
        fprintf(fp, "%s.V = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_DST_LAYER:
    
        parsed = data;
        fprintf(fp, "%s.V = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_DST_ORIGIN:
    
        parsed = (data >> 0) & ((1u << 16) - 1);
        fprintf(fp, "%s.X = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
    
        parsed = (data >> 16) & ((1u << 16) - 1);
        fprintf(fp, "%s.Y = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_SRC_BLOCK_SIZE:
    
        parsed = (data >> 0) & ((1u << 4) - 1);
        fprintf(fp, "%s.WIDTH = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_SRC_BLOCK_SIZE_WIDTH_ONE_GOB:
            fprintf(fp, "ONE_GOB\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 4) & ((1u << 4) - 1);
        fprintf(fp, "%s.HEIGHT = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_SRC_BLOCK_SIZE_HEIGHT_ONE_GOB:
            fprintf(fp, "ONE_GOB\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_HEIGHT_TWO_GOBS:
            fprintf(fp, "TWO_GOBS\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_HEIGHT_FOUR_GOBS:
            fprintf(fp, "FOUR_GOBS\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_HEIGHT_EIGHT_GOBS:
            fprintf(fp, "EIGHT_GOBS\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_HEIGHT_SIXTEEN_GOBS:
            fprintf(fp, "SIXTEEN_GOBS\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_HEIGHT_THIRTYTWO_GOBS:
            fprintf(fp, "THIRTYTWO_GOBS\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 8) & ((1u << 4) - 1);
        fprintf(fp, "%s.DEPTH = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_SRC_BLOCK_SIZE_DEPTH_ONE_GOB:
            fprintf(fp, "ONE_GOB\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_DEPTH_TWO_GOBS:
            fprintf(fp, "TWO_GOBS\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_DEPTH_FOUR_GOBS:
            fprintf(fp, "FOUR_GOBS\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_DEPTH_EIGHT_GOBS:
            fprintf(fp, "EIGHT_GOBS\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_DEPTH_SIXTEEN_GOBS:
            fprintf(fp, "SIXTEEN_GOBS\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_DEPTH_THIRTYTWO_GOBS:
            fprintf(fp, "THIRTYTWO_GOBS\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 12) & ((1u << 4) - 1);
        fprintf(fp, "%s.GOB_HEIGHT = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_SRC_BLOCK_SIZE_GOB_HEIGHT_GOB_HEIGHT_FERMI_8:
            fprintf(fp, "GOB_HEIGHT_FERMI_8\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
    
        parsed = (data >> 16) & ((1u << 2) - 1);
        fprintf(fp, "%s.KIND_BPP = ", prefix);
        switch (parsed) {
        case NVCAB5_SET_SRC_BLOCK_SIZE_KIND_BPP_BL_32:
            fprintf(fp, "BL_32\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_KIND_BPP_BL_8:
            fprintf(fp, "BL_8\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_KIND_BPP_BL_16:
            fprintf(fp, "BL_16\n");
            break;
        case NVCAB5_SET_SRC_BLOCK_SIZE_KIND_BPP_BL_24:
            fprintf(fp, "BL_24\n");
            break;
        default:
            fprintf(fp, "0x%x\n", parsed);
            break;
        }
        break;
    case NVCAB5_SET_SRC_WIDTH:
    
        parsed = data;
        fprintf(fp, "%s.V = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_SRC_HEIGHT:
    
        parsed = data;
        fprintf(fp, "%s.V = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_SRC_DEPTH:
    
        parsed = data;
        fprintf(fp, "%s.V = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_SRC_LAYER:
    
        parsed = data;
        fprintf(fp, "%s.V = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SET_SRC_ORIGIN:
    
        parsed = (data >> 0) & ((1u << 16) - 1);
        fprintf(fp, "%s.X = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
    
        parsed = (data >> 16) & ((1u << 16) - 1);
        fprintf(fp, "%s.Y = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SRC_ORIGIN_X:
    
        parsed = data;
        fprintf(fp, "%s.VALUE = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_SRC_ORIGIN_Y:
    
        parsed = data;
        fprintf(fp, "%s.VALUE = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_DST_ORIGIN_X:
    
        parsed = data;
        fprintf(fp, "%s.VALUE = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_DST_ORIGIN_Y:
    
        parsed = data;
        fprintf(fp, "%s.VALUE = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    case NVCAB5_PM_TRIGGER_END:
    
        parsed = data;
        fprintf(fp, "%s.V = ", prefix);
        fprintf(fp, "(0x%x)\n", parsed);
        break;
    default:
        fprintf(fp, "%s.VALUE = 0x%x\n", prefix, data);
        break;
    }
}
